
/**
 * information on program identifiers
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class IdentInfo
{
    static enum IDType {VARIABLE, CONSTANT, PROCEDURE};
    
    private IDType theType;
    private int address;        // for VARIABLEs
    private boolean isGlobal;   // for VARIABLEs
    private int value;          //for CONSTANTs
    private int entryPoint;     // for PROCEDUREs
    
    /**
     * Constructor for objects of class IDinfo
     */
    public IdentInfo()
    {
        
    }

    public IDType getType() {return theType;}
    public void   setType(IDType type) {theType = type;}
    
    /*# VARIABLE stuff */
    public int getAddr()
    {
        if (theType == IDType.VARIABLE) return address;
        else {
            error("IdentInfo called for VARIABLE attributes but is " + theType);
            return 0;
        }
    }
    
    public void setAddr(int addr)
    {
        if (theType == IDType.VARIABLE) address = addr;
        else {
            error("IdentInfo called for VARIABLE attributes but is " + theType);
        }
    }
    
    public boolean getIsGlobal() {
        if (theType == IDType.VARIABLE) return isGlobal;
        else {
            error("IdentInfo called for VARIABLE attributes but is " + theType);
            return false;
        }
    }
    
    public void setIsGlobal(boolean isg) {
        if (theType == IDType.VARIABLE) isGlobal = isg;
        else {
            error("IdentInfo called for VARIABLE attributes but is " + theType);
       }
    }
    
    public boolean isVar() {
        return theType == IDType.VARIABLE;
    }
    
    /*# CONSTANT stuff */
    public int getValue()
    {
        if (theType == IDType.CONSTANT) return value;
        else {
            error("IdentInfo called for CONSTANT attributes but is " + theType);
            return 0;
        }
    }
    
    public void setValue(int val)
    {
        if (theType == IDType.CONSTANT) value = val;
        else {
            error("IdentInfo called for CONSTANT attributes but is " + theType);
        }
    }
 
    public boolean isConst() {
        return theType == IDType.CONSTANT;
    }
    
    /*# PROCEDURE stuff */
    
    public int getEntryPoint()
    {
        if (theType == IDType.PROCEDURE) return entryPoint;
        else {
            error("IdentInfo called for PROCEDURE attributes but is " + theType);
            return 0;
        }
    }
    
    public void setEntryPoint(int ep)
    {
        if (theType == IDType.PROCEDURE) entryPoint = ep;
        else {
            error("IdentInfo called for PROCEDURE attributes but is " + theType);
        }
    }
 
    public boolean isProc() {
        return theType == IDType.PROCEDURE;
    }
 
    private void error(String s) {
        System.err.println(s);
    }
}
